#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Oct 22 16:57:19 2020

@author: 
"""

import tensorflow as tf
import tensorflow.keras as keras

def sparse_categorical_error(y_true, y_pred):


    y_pred = tf.reshape(tf.argmax(y_pred, axis=1), shape=(-1, 1))
    y_pred = tf.cast(y_pred, "int32")
    y_true = tf.cast(y_true, "int32")
    
    values = tf.not_equal(y_true, y_pred)
    values = tf.cast(values, "float32")
        
    return values    
    

class SparseCategoricalError(keras.metrics.Mean):
    
    def __init__(self, name='sparse_categorical_error', **kwargs):
        super(SparseCategoricalError, self).__init__(name=name, **kwargs)
    
    def update_state(self, y_true, y_pred, sample_weight=None):
        
        values = sparse_categorical_error(y_true, y_pred)
        return super(SparseCategoricalError, self).update_state(values, sample_weight)
 
    