#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Feb 10 10:54:22 2021

@author: 
"""
import tensorflow as tf
import tensorflow.keras as keras
import matplotlib.pyplot as plt

from collections import defaultdict


class Profile(keras.callbacks.Callback):
    
    def __init__(self):

        super(Profile, self).__init__()        
        self.total_sparsity_rate = []

        self.sparsity_rates = defaultdict(list)

        
    def on_train_begin(self, logs=None):
        self.record()

    def on_epoch_end(self, epoch, logs=None):
        self.record()        
        
        
    
    def record(self):
        
        profile, stage_profile = self.model.profile()
        sparsity_rate = profile['sparsity_rate']
        self.total_sparsity_rate.append(sparsity_rate)

        for key, value in stage_profile.items():
            self.sparsity_rates[key].append(value['sparsity_rate'])
            
        plt.figure()
        plt.title('Sparsity Rate')            
        plt.plot(self.total_sparsity_rate)        
        plt.show()
        
        sparsity_per_layer = [value[-1] * 100 for key, value in self.sparsity_rates.items()]
        plt.figure()
        plt.plot(sparsity_per_layer)
        plt.title('Sparsity Rate per Layer')
        plt.show()
        
        
        print(stage_profile)
        print(profile)